clash-lib-1.8.4: Clash: a functional hardware description language - As a library

Copyright | (C) 2017 Google Inc. 2023 QBayLogic B.V.
License | BSD2 (see the file LICENSE)
Maintainer | QBayLogic B.V. <devops@qbaylogic.com>
Safe Haskell | None
Language | Haskell2010

GHC.BasicTypes.Extra

Contents

- Orphan instances

Description

Synopsis

- isNoInline :: InlineSpec -> Bool
- isOpaque :: InlineSpec -> Bool

# Documentation

isNoInline :: InlineSpec -> Bool Source #

Determine whether given `InlineSpec` is NOINLINE or more strict (OPAQUE)

isOpaque :: InlineSpec -> Bool Source #

Determine whether given `InlineSpec` is OPAQUE. If this function is used on a GHC that does not support OPAQUE yet (<9.4), it will return `True` if given `InlineSpec` is NOINLINE instead.

# Orphan instances

Binary FastString Source # |
Instance details Methods put :: FastString -> Put Source # get :: Get FastString Source # putList :: [FastString] -> Put Source #
Binary FastZString Source # |
Instance details Methods put :: FastZString -> Put Source # get :: Get FastZString Source # putList :: [FastZString] -> Put Source #
Binary InlineSpec Source # |
Instance details Methods put :: InlineSpec -> Put Source # get :: Get InlineSpec Source # putList :: [InlineSpec] -> Put Source #
Binary SourceText Source # |
Instance details Methods put :: SourceText -> Put Source # get :: Get SourceText Source # putList :: [SourceText] -> Put Source #
NFData InlineSpec Source # |
Instance details Methods rnf :: InlineSpec -> () Source #
Generic FastString Source # |

Instance details

Associated Types

type Rep FastString |

Instance details

Defined in GHC.BasicTypes.Extra

type Rep FastString = D1 ('MetaData "FastString" "GHC.Data.FastString" "ghc-9.10.3-inplace" 'False) (C1 ('MetaCons "FastString" 'PrefixI 'True) ((S1 ('MetaSel ('Just "uniq") 'SourceUnpack 'SourceStrict 'DecidedUnpack) (Rec0 Int) :*: S1 ('MetaSel ('Just "n_chars") 'SourceUnpack 'SourceStrict 'DecidedUnpack) (Rec0 Int)) :*: (S1 ('MetaSel ('Just "fs_sbs") 'SourceUnpack 'SourceStrict 'DecidedUnpack) (Rec0 ShortByteString) :*: S1 ('MetaSel ('Just "fs_zenc") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 FastZString))))

Methods

from :: FastString -> Rep FastString x Source #

to :: Rep FastString x -> FastString Source #

Generic InlineSpec Source # |

Instance details

Associated Types

type Rep InlineSpec |

Instance details

Defined in GHC.BasicTypes.Extra

type Rep InlineSpec = D1 ('MetaData "InlineSpec" "GHC.Types.Basic" "ghc-9.10.3-inplace" 'False) ((C1 ('MetaCons "Inline" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 SourceText)) :+: C1 ('MetaCons "Inlinable" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 SourceText))) :+: (C1 ('MetaCons "NoInline" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 SourceText)) :+: (C1 ('MetaCons "Opaque" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 SourceText)) :+: C1 ('MetaCons "NoUserInlinePrag" 'PrefixI 'False) (U1 :: Type -> Type))))

Methods

from :: InlineSpec -> Rep InlineSpec x Source #

to :: Rep InlineSpec x -> InlineSpec Source #

Generic SourceText Source # |

Instance details

Associated Types

type Rep SourceText |
Instance details Defined in GHC.BasicTypes.Extra type Rep SourceText = D1 ('MetaData "SourceText" "GHC.Types.SourceText" "ghc-9.10.3-inplace" 'False) (C1 ('MetaCons "SourceText" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 FastString)) :+: C1 ('MetaCons "NoSourceText" 'PrefixI 'False) (U1 :: Type -> Type))

Methods

from :: SourceText -> Rep SourceText x Source #

to :: Rep SourceText x -> SourceText Source #